*ͻ*
*   Module Name:   TBSIMPLE.PRG                                    *
*   Description:   Shows the bare essentials of a TBrowse.         *
*                  It ain't pretty, but it's not meant to be.      *
*   Notes......:   COMPILE with the /n/w switch.                   *
*   Author.....:   Micheal Todd Charron                            *
*   Date.......:   March 21, 1991                                  *
*   History....:   Written on March 21, 1991.  10 minutes on code. *
*                  4 hours on comments.                            *
*                                                                  *
*   Copyright..:   (c) The people at Nantucket Canada, 1991        *
*ͼ*
#include "inkey.ch"

FUNCTION MAIN()
	LOCAL nI, nKey
	LOCAL oBrowse := TBROWSEDB( 1, 5, 24, 75 )

	CLS

	USE DBTEST

	FOR nI := 1 TO FCOUNT()
		oBrowse:ADDCOLUMN( TBCOLUMNNEW( FIELD( nI ),;
			FIELDBLOCK( FIELD( nI ) ) ) )
	NEXT nI

	DO WHILE nKey != K_ESC

		DO WHILE ! oBrowse:STABILIZE()
		ENDDO

		nKey := INKEY( 0 )

		DO CASE
		CASE nKey == K_DOWN
			oBrowse:DOWN()
		CASE nKey == K_UP
			oBrowse:UP()
		CASE nKey == K_LEFT
			oBrowse:LEFT()
		CASE nKey == K_RIGHT
			oBrowse:RIGHT()
		ENDCASE

	ENDDO

RETURN Nil

/*****************************************************************************
        ͸
Line 17   LOCAL oBrowse := TBROWSEDB( 1, 5, 24, 75 )                        
        ;
Creates the TBrowse object with the display boundaries of a left column of 1,
a top row of 5, a bottom row of 24, and a right row of 75.  At the same time
that the object is created, a reference to that object is assigned to the
variable "oBrowse".  Now routines performed on the object can use the
reference contained in "oBrowse".

        ͸
Line 21   USE DBTEST                                                        
        ;
I open my current database.  For this example I don't open an index file, but
it makes little difference to the TBrowse.  This database, by the way,
contains User Group information.  If you are not a member of a local User
Group, join one.  They are immensely helpful in retrieving new ideas and
information.

        ͸
Line 23	  FOR nI := 1 TO FCOUNT()                                           
Line 24	    	oBrowse:ADDCOLUMN( TBCOLUMNNEW( FIELD( nI ),;                
Line 25	 	  	FIELDBLOCK( FIELD( nI ) ) ) )                        
Line 26	  NEXT nI                                                           
        ;
From the first field in the database to the last field in the database, a new
column object is created with each iteration of the FOR...NEXT loop.  If you
do not want to control any aspects of the column like color, width, cargo,
separators (heading, footing, column) or the footing, you can add the
reference for the column object, created by TBCOLUMNNEW(), directly to the 
TBrowse object.

TBCOLUMNNEW takes two arguments.  The first one is the heading of the column.
In this case I use the FIELD() function in order to give me a heading of the
Field Name.  The second argument is the code block that is evaluated to
display the contents of field in the the current column.

FIELDBLOCK() basically takes the field name and inserts it into a code block.
If for instance you gave FIELDBLOCK() the database field ADDRESS as an
argument then FIELDBLOCK( "ADDRESS" ) would return something similar to
{ | x | IF( x == Nil, FIELD->ADDRESS, FIELD->ADDRESS := x ) }.  That Code
Block would be evaluated for the column and give you the value in the ADDRESS
field for the current record.

        ͸
Line 30	  DO WHILE ! oBrowse:STABILIZE()				     
Line 31	  ENDDO                                                             
        ;
The loop basically looks to see if there are any changes, to any of the rows,
since the last time it ran through the loop.  The oBrowse:STABILIZE() will
not return TRUE until all changed rows have been redrawn.  The first time the
loop is reached oBrowse:STABILIZE() will loop as many times as it takes to
redraw every row, because at that point every row has changed.

If you decide to change the value of a field in a record that is showing on
the screen, you would issue an oBrowse:REFRESHCURRENT().  This tells TBrowse
to redraw the current row when it reaches the loop.  In this case, you would
go through the loop one time.

        ͸
Line 33	  nKey := INKEY( 0 )					             
	                                                                    
Line 35	  DO CASE							     
Line 36	  CASE nKey == K_DOWN					             
Line 37		oBrowse:DOWN()					             
Line 38	  CASE nKey == K_UP					             
Line 39		oBrowse:UP()					             
Line 40	  CASE nKey == K_LEFT					             
Line 41		oBrowse:LEFT()					             
Line 42	  CASE nKey == K_RIGHT					             
Line 44		oBrowse:RIGHT()					             
Line 45	  ENDCASE                                                           
        ;
In the section above, line 21 simply waits for a keypress and assigns it to
the "nKey" variable.  The rest of the lines just send the methods to the
object referenced by the "oBrowse" variable and perform the requested action.

*******************************************************************************
           Anything else you add to this is icing on the cake.
******************************************************************************/
